﻿B4i=true
Group=Модули
ModulesStructureVersion=1
Type=StaticCode
Version=5.51
@EndOfDesignText@
'Code module

Sub Process_Globals

    Dim nativeObjectInstance                                                    As NativeObject

End Sub

Public Sub setPageDecor (navigationControllerCurrent As NavigationController, byteVariant As Byte)    
    
    nativeObjectInstance = navigationControllerCurrent
    nativeObjectInstance.GetField ("navigationBar").RunMethod ("setBarStyle:", Array (0)) ' default = 0 black = 1 blackTranslucent = 2
    nativeObjectInstance.GetField ("navigationBar").RunMethod ("setTranslucent:", Array (False))
	nativeObjectInstance.GetField ("navigationBar").RunMethod ("setBarTintColor:", Array (nativeObjectInstance.ColorToUIColor (0xFFFECC00)))
        
	
End Sub

#if OBJC
-(void) setStatusBarStyle: (NSInteger) style { UIApplication.sharedApplication.statusBarStyle = style; }
#End If

Public Sub setNavigationControllerTag (shouldAutorotate As Boolean, prefersLightStatusBarStyle As Boolean, prefersStatusBarHidden As Boolean)

    Dim mapInstance                                               As Map

    mapInstance.Initialize

    mapInstance.Put ("shouldAutorotate",           shouldAutorotate)
    mapInstance.Put ("prefersLightStatusBarStyle", prefersLightStatusBarStyle)
    mapInstance.Put ("prefersStatusBarHidden",     prefersStatusBarHidden)

    dataCommon.navigationcontrollerInstance.Tag = mapInstance.ToDictionary
    If dataCommon.navigationcontrollerSideMenu.IsInitialized Then dataCommon.navigationcontrollerSideMenu.Tag = mapInstance.ToDictionary

End Sub

Public Sub setFlagsAndShowPage (navigationControllerInstance As NavigationController, pageInstance As Page, shouldAutorotate As Boolean, prefersLightStatusBarStyle As Boolean, prefersStatusBarHidden As Boolean)

    Dim nativeObjectInstance                                      As NativeObject

    setNavigationControllerTag (shouldAutorotate, prefersLightStatusBarStyle, prefersStatusBarHidden)

    #If SeparateSBA
    ' Theoretically not needed
    nativeObjectInstance = navigationControllerInstance
    nativeObjectInstance.RunMethod ("setNeedsStatusBarAppearanceUpdate", Null)
    Sleep (1)
    #End If
    navigationControllerInstance.ShowPage2 (pageInstance, False)

End Sub

Public Sub setRotateFlagOnly (shouldAutorotate As Boolean)

    Dim prefersLightStatusBarStyle                                As Boolean
    Dim prefersStatusBarHidden                                    As Boolean

    Dim mapInstance                                               As Map
    Dim nativeObjectInstance                                      As NativeObject

    mapInstance = nativeObjectInstance.Initialize ("B4IMap").RunMethod ("convertToMap:",  Array (dataCommon.navigationControllerInstance.Tag))
    If mapInstance.Get ("prefersLightStatusBarStyle") <> 0 Then prefersLightStatusBarStyle = True
    If mapInstance.Get ("prefersStatusBarHidden") <> 0 Then prefersStatusBarHidden = True
    setNavigationControllerTag (shouldAutorotate, prefersLightStatusBarStyle, prefersStatusBarHidden)

End Sub

#if OBJC
@end
@interface UINavigationController (SM)
@end
@implementation UINavigationController (SM)
- (BOOL) shouldAutorotate
    {
    NSDictionary* map1    = [B4IObjectWrapper getMap: self];
    NSDictionary* map2    = map1 [@"tag"];
    NSNumber*     number  = map2 [@"shouldAutorotate"];
    return number.boolValue;
    }

- (BOOL) prefersStatusBarHidden
    {
    NSDictionary* map1 = [B4IObjectWrapper getMap: self];
    NSDictionary* map2 = map1 [@"tag"];
    NSNumber* number = map2 [@"prefersStatusBarHidden"];
    return number.boolValue;
    }

- (UIStatusBarStyle) preferredStatusBarStyle
    {
    NSDictionary* map1   = [B4IObjectWrapper getMap: self];
    NSDictionary* map2   = map1 [@"tag"];
    NSNumber*     number = map2 [@"prefersLightStatusBarStyle"];
    if (@available (iOS 13, *))
        { if (number.boolValue) { NSLog (@"NC Light"); return UIStatusBarStyleLightContent; } else {  NSLog (@"NC Dark"); return UIStatusBarStyleDarkContent; }; }
    else
        { if (number.boolValue) { return UIStatusBarStyleLightContent; } else { return UIStatusBarStyleDefault; }; };
    }

//  Theoretically not needed
- (UIViewController*) childViewControllerForStatusBarHidden { return nil; }
- (UIViewController*) childViewControllerForStatusBarStyle  { return nil; }
#End If

#End Region

#if OBJC
@end
@interface UIViewController (SM)
@end
@implementation UIViewController (SM)
- (BOOL) shouldAutorotate
    {
    if ([self isKindOfClass: NSClassFromString (@"MMDrawerController")])
        {
        NSDictionary* map = [B4IObjectWrapper getMap: self];
        NSNumber* n = map [@"tag"];
        return n.boolValue;
        }
    return true;
    }

- (BOOL) prefersStatusBarHidden
    {
    NSDictionary* map1 = [B4IObjectWrapper getMap: self];
    NSDictionary* map2 = map1 [@"tag"];
    NSNumber* number = map2 [@"prefersStatusBarHidden"];
    return number.boolValue;
    }

- (UIStatusBarStyle) preferredStatusBarStyle
    {
    NSDictionary* map1   = [B4IObjectWrapper getMap: self];
    NSDictionary* map2   = map1 [@"tag"];
    NSNumber*     number = map2 [@"prefersLightStatusBarStyle"];
    if (@available (iOS 13, *))
        { if (number.boolValue) { NSLog (@"VC Light"); return UIStatusBarStyleLightContent; } else {  NSLog (@"VC Dark"); return UIStatusBarStyleDarkContent; }; }
    else
        { if (number.boolValue) { return UIStatusBarStyleLightContent; } else { return UIStatusBarStyleDefault; }; };
    }

//  Theoretically not needed
- (UIViewController*) childViewControllerForStatusBarHidden { return nil; }
- (UIViewController*) childViewControllerForStatusBarStyle  { return nil; }
#End If
